var History = Class.create();
History.prototype =
{
    date: null,
    items: null,
    getDate: function() { return this.date; },
    initialize: function(date, items) {
        this.date = date;
        this.items = items;
    },
    toNode: function() {
        var divNode = document.createElement('div');
        var dateNode = document.createElement('h2');
        dateNode.appendChild(document.createTextNode(this.date.toString()));
        var itemsNode = document.createElement('ul');
        this.items.each(function(item){
            var itemNode = document.createElement('li');
            itemNode.appendChild(document.createTextNode(item));
            itemsNode.appendChild(itemNode);
        });
        divNode.appendChild(dateNode);
        divNode.appendChild(itemsNode);
        return divNode;
    }
};

/* ------------------------------------------------------------------------------ */

var HISTORY_BLOCK_ID = 'history';
var HISTORY_FILE_URI = '/history.xml';

/* ------------------------------------------------------------------------------ */

// onload
addEvent(window, 'load', showHistory);

/* ------------------------------------------------------------------------------ */

function showHistory() {
    createLoading();
    showLoading();
    new Ajax.Request(
        HISTORY_FILE_URI,
        {
            method: 'get',
            onSuccess: historySuccess,
            onComplete: historyComplete,
            onFailure: historyFailure
        }
    );
}

function historySuccess(file) {
    hideLoading();
    addHistories(file.responseXML.documentElement);
}
function historyComplete() { }
function historyFailure() { }

/* ------------------------------------------------------------------------------ */

function addHistories(root) {
    var historyBlock = $(HISTORY_BLOCK_ID);
    var histories = $A(root.getElementsByTagName('history'));
    var historyList = new Array();
    histories.each(function(history){
        var date = getDate(history);
        var items = getItems(history);
        var historyObj = new History(date, items);
        historyList.push(historyObj);
    });
    historyList.sort(historyListSortFunction);
    historyList.each(function(history){
        var historyNode = history.toNode();
        historyBlock.appendChild(historyNode);
    });
    removeLoading();
}

function historyListSortFunction(a, b) {
    return b.getDate().getTime() - a.getDate().getTime();
}

function getDate(history) {
    var dateElement = history.getElementsByTagName('date')[0];
    return new Date(dateElement.firstChild.nodeValue);
}

function getItems(history) {
    var itemsElement = history.getElementsByTagName('items')[0];
    var itemElements = $A(itemsElement.getElementsByTagName('item'));
    var items = new Array();
    itemElements.each(function(itemElement){
        items.push(itemElement.firstChild.nodeValue);
    });
    return items;
}
